(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/forms'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('nthm', ['exports', '@angular/common', '@angular/core', '@angular/forms', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.nthm = {}, global.ng.common, global.ng.core, global.ng.forms, global.rxjs, global.rxjs.operators));
}(this, (function (exports, common, core, forms, rxjs, operators) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var styleProperties = Object.freeze([
        'direction',
        'boxSizing',
        'width',
        'height', 'minHeight', 'minWidth', 'overflowX',
        'overflowY',
        'borderTopWidth', 'borderRightWidth', 'borderBottomWidth', 'borderLeftWidth', 'borderStyle',
        'paddingTop', 'paddingRight', 'paddingBottom', 'paddingLeft',
        // https://developer.mozilla.org/en-US/docs/Web/CSS/font
        'fontStyle', 'fontVariant', 'fontWeight', 'fontStretch', 'fontSize', 'fontSizeAdjust', 'lineHeight', 'fontFamily',
        'textAlign', 'textTransform', 'textIndent',
        'textDecoration',
        'letterSpacing', 'wordSpacing',
        'tabSize', 'MozTabSize'
    ]);
    var isBrowser = typeof window !== 'undefined';
    var isFirefox = isBrowser && window.mozInnerScreenX != null;
    function isInputOrTextAreaElement(element) {
        return element !== null &&
            (element.nodeName === 'INPUT' || element.nodeName === 'TEXTAREA' || element.nodeName === '#text');
    }
    function spliceString(value, start, end, insert) {
        return value.substring(0, start) + insert + value.substring(end) + '';
    }
    function iterateMentionsMarkup(value, mentionMarkup, textIterator, markupIterator, displayTransform) {
        var match, start = 0, currentPlainTextIndex = 0;
        var regEx = mentionMarkup.regEx;
        regEx.lastIndex = 0;
        while ((match = regEx.exec(value)) !== null) {
            var display = displayTransform.apply(void 0, __spread(match));
            var substr = value.substring(start, match.index);
            textIterator(substr, start, currentPlainTextIndex);
            currentPlainTextIndex += substr.length;
            markupIterator(match[0], match.index, currentPlainTextIndex, display);
            currentPlainTextIndex += display.length;
            start = regEx.lastIndex;
        }
        if (start < value.length) {
            textIterator(value.substring(start), start, currentPlainTextIndex);
        }
    }
    function iterateOnlyMentionsMarkup(value, mentionMarkup, markupIterator, displayTransform) {
        var match, start = 0, currentPlainTextIndex = 0;
        var regEx = mentionMarkup.regEx;
        regEx.lastIndex = 0;
        while ((match = regEx.exec(value)) !== null) {
            var display = displayTransform.apply(void 0, __spread(match));
            var substr = value.substring(start, match.index);
            currentPlainTextIndex += substr.length;
            markupIterator(match[0], match.index, currentPlainTextIndex, display);
            currentPlainTextIndex += display.length;
            start = regEx.lastIndex;
        }
    }
    function mapPlainTextIndex(value, mentionMarkup, indexInPlainText, toEndOfMarkup, displayTransform) {
        if (isNaN(indexInPlainText)) {
            return indexInPlainText;
        }
        var result;
        var textIterator = function (matchString, index, substringPlainTextIndex) {
            if (typeof result !== 'undefined') {
                return;
            }
            if (substringPlainTextIndex + matchString.length >= indexInPlainText) {
                result = index + indexInPlainText - substringPlainTextIndex;
            }
        };
        var markupIterator = function (matchString, index, mentionPlainTextIndex, display) {
            if (typeof result !== 'undefined') {
                return;
            }
            if (mentionPlainTextIndex + display.length > indexInPlainText) {
                result = index + (toEndOfMarkup ? matchString.length : 0);
            }
        };
        iterateMentionsMarkup(value, mentionMarkup, textIterator, markupIterator, displayTransform);
        return typeof result !== 'undefined' ? result : value.length;
    }
    function getCaretPosition(element) {
        if (isInputOrTextAreaElement(element)) {
            var value = element.value;
            return value.slice(0, element.selectionStart).length;
        }
        var selection = window.getSelection();
        if (selection.rangeCount > 0) {
            var range = selection.getRangeAt(0);
            return range.startOffset;
        }
        return 0;
    }
    function getCaretCoordinates(element, position) {
        var coords = { top: 0, left: 0 };
        if (!isBrowser) {
            return coords;
        }
        var div = document.createElement('div');
        document.body.appendChild(div);
        var style = div.style;
        var computed = getElementStyle(element);
        style.whiteSpace = 'pre-wrap';
        if (element.nodeName !== 'INPUT') {
            style.wordWrap = 'break-word';
        }
        style.position = 'absolute';
        style.visibility = 'hidden';
        styleProperties.forEach(function (prop) { return style[prop] = computed[prop]; });
        if (isFirefox) {
            if (element.scrollHeight > parseInt(computed.height, 10)) {
                style.overflowY = 'scroll';
            }
        }
        else {
            style.overflow = 'hidden';
        }
        div.textContent = element.value.substring(0, position);
        if (element.nodeName === 'INPUT') {
            div.textContent = div.textContent.replace(/\s/g, '\u00a0');
        }
        var span = document.createElement('span');
        span.textContent = element.value.substring(position) || '.';
        div.appendChild(span);
        var scrollTop = 0;
        if (element.scrollTop > 0) {
            scrollTop = element.scrollTop;
        }
        coords = {
            top: span.offsetTop + parseInt(computed['borderTopWidth'], 10) - scrollTop,
            left: span.offsetLeft + parseInt(computed['borderLeftWidth'], 10)
        };
        document.body.removeChild(div);
        return coords;
    }
    function getElementStyle(element, property) {
        var style = window.getComputedStyle ? getComputedStyle(element) : element.currentStyle;
        if (property && typeof property === 'string' && typeof style[property] !== 'undefined') {
            return style[property];
        }
        else if (property && typeof property === 'string') {
            return null;
        }
        return style;
    }
    function setCaretPosition(element, position) {
        if (isInputOrTextAreaElement(element) && element.selectionStart !== undefined) {
            element.focus();
            element.setSelectionRange(position, position);
        }
        else {
            var range = document.createRange();
            range.setStart(element, position);
            range.collapse(true);
            var selection = window.getSelection();
            selection.removeAllRanges();
            selection.addRange(range);
        }
    }
    function escapeRegExp(str) {
        return str.replace(/[-\/\\^$*+?.()|[\]{}]/g, '\\$&');
    }
    function markupToRegExp(markup) {
        var placeholderRegExp = /__([\w]+)__/g;
        var placeholderExclusion = '^\\)\\]';
        var markupPattern = escapeRegExp(markup);
        var placeholders = {};
        var match, i = 1;
        do {
            match = placeholderRegExp.exec(markupPattern);
            if (match) {
                var placeholder = match[1];
                markupPattern = markupPattern.replace("__" + placeholder + "__", "([" + placeholderExclusion + "]+)");
                placeholders[placeholder] = ++i;
            }
        } while (match);
        return { markup: markup, regEx: new RegExp('(' + markupPattern + ')', 'ig'), groups: placeholders };
    }
    function getPlainText(value, mentionMarkup, displayTransform) {
        mentionMarkup.regEx.lastIndex = 0;
        return value.replace(mentionMarkup.regEx, displayTransform);
    }
    function replacePlaceholders(item, markupMention) {
        var result = markupMention.markup + '';
        Object.keys(markupMention.groups)
            .forEach(function (key) { return result = result.replace(new RegExp("__" + key + "__", 'g'), typeof item === 'string' ? item : item[key]); });
        return result;
    }
    function applyChangeToValue(value, markupMention, plainTextValue, selectionStartBeforeChange, selectionEndBeforeChange, selectionEndAfterChange, displayTransform) {
        if (selectionStartBeforeChange === void 0) { selectionStartBeforeChange = 0; }
        if (selectionEndBeforeChange === void 0) { selectionEndBeforeChange = 0; }
        if (selectionEndAfterChange === void 0) { selectionEndAfterChange = 0; }
        var oldPlainTextValue = getPlainText(value, markupMention, displayTransform);
        var lengthDelta = oldPlainTextValue.length - plainTextValue.length;
        if (!selectionStartBeforeChange) {
            selectionStartBeforeChange = selectionEndBeforeChange + lengthDelta;
        }
        if (!selectionEndBeforeChange) {
            selectionEndBeforeChange = selectionStartBeforeChange;
        }
        if (selectionStartBeforeChange === selectionEndBeforeChange && selectionEndBeforeChange === selectionEndAfterChange &&
            oldPlainTextValue.length === plainTextValue.length) {
            selectionStartBeforeChange--;
        }
        var insert = plainTextValue.slice(selectionStartBeforeChange, selectionEndAfterChange);
        var spliceStart = Math.min(selectionStartBeforeChange, selectionEndAfterChange);
        var spliceEnd = selectionEndBeforeChange;
        if (selectionStartBeforeChange === selectionEndAfterChange) {
            spliceEnd = Math.max(selectionEndBeforeChange, selectionStartBeforeChange + lengthDelta);
        }
        return spliceString(value, mapPlainTextIndex(value, markupMention, spliceStart, false, displayTransform), mapPlainTextIndex(value, markupMention, spliceEnd, true, displayTransform), insert);
    }
    function findStartOfMentionInPlainText(value, mentionMarkup, indexInPlainText, displayTransform) {
        var result = { start: -1, end: -1 };
        var markupIterator = function (matchString, index, mentionPlainTextIndex, display) {
            if (mentionPlainTextIndex < indexInPlainText && mentionPlainTextIndex + display.length > indexInPlainText) {
                result = { start: mentionPlainTextIndex, end: mentionPlainTextIndex + display.length };
                return true;
            }
            return false;
        };
        iterateOnlyMentionsMarkup(value, mentionMarkup, markupIterator, displayTransform);
        return result;
    }
    function getBoundsOfMentionAtPosition(value, mentionMarkup, indexInPlainText, displayTransform) {
        return findStartOfMentionInPlainText(value, mentionMarkup, indexInPlainText, displayTransform);
    }
    function escapeHtml(text) {
        return text.replace(/</g, '&lt;').replace(/>/g, '&gt;');
    }
    function isCoordinateWithinRect(rect, x, y) {
        return (rect.left < x && x < rect.right) && (rect.top < y && y < rect.bottom);
    }
    var Highlighted = /** @class */ (function () {
        function Highlighted(element, type) {
            if (type === void 0) { type = null; }
            this.element = element;
            this.type = type;
        }
        Object.defineProperty(Highlighted.prototype, "clientRect", {
            get: function () {
                return this.element.getBoundingClientRect();
            },
            enumerable: false,
            configurable: true
        });
        return Highlighted;
    }());

    /**
     * The Highlighted Pattern Directive
     */
    var NgHighlighterPatternDirective = /** @class */ (function () {
        function NgHighlighterPatternDirective() {
            var _this = this;
            this.format = function (content) {
                var e_1, _a;
                if (typeof _this.markupReplace === 'string') {
                    var result = void 0;
                    var replaceTries = [_this.markupReplace, "$" + _this.markupReplace, "$" + _this.markupMention.groups[_this.markupReplace]];
                    try {
                        for (var replaceTries_1 = __values(replaceTries), replaceTries_1_1 = replaceTries_1.next(); !replaceTries_1_1.done; replaceTries_1_1 = replaceTries_1.next()) {
                            var attempt = replaceTries_1_1.value;
                            result = content.replace(_this.markupMention.regEx, attempt);
                            if (result !== attempt) {
                                break;
                            }
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (replaceTries_1_1 && !replaceTries_1_1.done && (_a = replaceTries_1.return)) _a.call(replaceTries_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                    return result;
                }
                else if (typeof _this.markupReplace === 'function') {
                    return _this.markupReplace(content);
                }
                return content;
            };
        }
        NgHighlighterPatternDirective.prototype.ngOnInit = function () {
            if (this.markup) {
                this.markupMention = markupToRegExp(this.markup);
            }
        };
        NgHighlighterPatternDirective.prototype.ngOnChanges = function (changes) {
            if ('markup' in changes) {
                this.markupMention = markupToRegExp(this.markup);
            }
        };
        NgHighlighterPatternDirective.prototype.match = function (value) {
            return this.markupMention ? this.markupMention.regEx.exec(value) : null;
        };
        return NgHighlighterPatternDirective;
    }());
    NgHighlighterPatternDirective.decorators = [
        { type: core.Directive, args: [{ exportAs: 'ngHighlighterPattern', selector: 'ng-highlighter-pattern' },] }
    ];
    NgHighlighterPatternDirective.propDecorators = {
        className: [{ type: core.Input }],
        markup: [{ type: core.Input }],
        markupReplace: [{ type: core.Input }]
    };

    /**
     * The Highlighted Value
     */
    var NgHighlightedValue = /** @class */ (function () {
        function NgHighlightedValue(content, type, rel) {
            if (type === void 0) { type = null; }
            if (rel === void 0) { rel = null; }
            /**
             * The type (or class name) associated with the highlighted item that was clicked.
             * @see NgHighlighterPatternDirective.className
             */
            this.type = null;
            /**
             * Optional. Arbitrary rel associated with the clicked highlighted element.
             * This is determined by how the highlighted item's content is formatted.
             */
            this.rel = null;
            this.content = content;
            this.type = type;
            this.rel = rel;
        }
        return NgHighlightedValue;
    }());

    /**
     * The Highlighter Component
     */
    var NgHighlighterComponent = /** @class */ (function () {
        function NgHighlighterComponent(element, cdr) {
            this.element = element;
            this.cdr = cdr;
            /**
             * Event emitted when a highlighted item it clicked
             */
            this.itemClick = new core.EventEmitter();
            this.newLine = /\n/g;
            this.lines = [];
            this.highlightedElements = [];
        }
        NgHighlighterComponent.prototype.ngOnChanges = function (changes) {
            if ('text' in changes) {
                this.parseLines();
            }
        };
        NgHighlighterComponent.prototype.ngAfterContentInit = function () {
            if (this.text && this.patterns) {
                this.parseLines();
            }
        };
        NgHighlighterComponent.prototype.onItemClick = function (event) {
            var matchedElement = this.getMatchedElement(event);
            if (matchedElement) {
                event.preventDefault();
                event.stopPropagation();
                var content = matchedElement.element.innerText;
                var rel = matchedElement.element.getAttribute('rel') || null;
                var relElement = matchedElement.element.querySelector('[rel]');
                if (relElement) {
                    rel = relElement.getAttribute('rel') || null;
                }
                this.itemClick.emit(new NgHighlightedValue(content, matchedElement.type, rel));
            }
        };
        NgHighlighterComponent.prototype.parseLines = function () {
            var _this = this;
            this.lines = this.text.split(this.newLine).map(function (line) { return _this.highlight(line); });
            this.cdr.detectChanges();
            this.collectHighlightedItems();
        };
        NgHighlighterComponent.prototype.highlight = function (line) {
            if (line.length === 0 || !this.patterns) {
                return '&nbsp;';
            }
            var tags = [];
            var match;
            this.patterns.forEach(function (pattern) {
                while ((match = pattern.match(line)) !== null) {
                    tags.push({
                        type: pattern.className,
                        indices: { start: match.index, end: match.index + match[0].length },
                        formatter: pattern.format
                    });
                }
            });
            var prevTags = [];
            var parts = [];
            __spread(tags).sort(function (tagA, tagB) { return tagA.indices.start - tagB.indices.start; }).forEach(function (tag) {
                var expectedLength = tag.indices.end - tag.indices.start;
                var contents = line.slice(tag.indices.start, tag.indices.end);
                if (contents.length === expectedLength) {
                    var prevIndex = prevTags.length > 0 ? prevTags[prevTags.length - 1].indices.end : 0;
                    var before = line.slice(prevIndex, tag.indices.start);
                    parts.push(escapeHtml(before));
                    parts.push("<span class=\"highlighted " + (tag.type || '') + "\" rel=\"" + tag.type + "\">" + tag.formatter(contents) + "</span>");
                    prevTags.push(tag);
                }
            });
            var remainingStart = prevTags.length > 0 ? prevTags[prevTags.length - 1].indices.end : 0;
            var remaining = line.slice(remainingStart);
            parts.push(escapeHtml(remaining));
            parts.push('&nbsp;');
            return parts.join('');
        };
        NgHighlighterComponent.prototype.getMatchedElement = function (event) {
            var matched = this.highlightedElements.find(function (el) { return isCoordinateWithinRect(el.clientRect, event.clientX, event.clientY); });
            return matched ? matched : null;
        };
        NgHighlighterComponent.prototype.collectHighlightedItems = function () {
            this.highlightedElements = Array.from(this.element.nativeElement.getElementsByClassName('highlighted'))
                .map(function (element) {
                var type = element.getAttribute('rel') || null;
                return new Highlighted(element, type);
            });
        };
        return NgHighlighterComponent;
    }());
    NgHighlighterComponent.decorators = [
        { type: core.Component, args: [{
                    exportAs: 'ngHighlighter',
                    selector: 'ng-highlighter',
                    template: '<div *ngFor="let line of lines" [innerHTML]="line"></div>',
                    preserveWhitespaces: false,
                    encapsulation: core.ViewEncapsulation.None
                },] }
    ];
    NgHighlighterComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.ChangeDetectorRef }
    ]; };
    NgHighlighterComponent.propDecorators = {
        text: [{ type: core.Input }],
        itemClick: [{ type: core.Output }],
        patterns: [{ type: core.ContentChildren, args: [NgHighlighterPatternDirective,] }],
        onItemClick: [{ type: core.HostListener, args: ['click', ['$event'],] }]
    };

    var Key;
    (function (Key) {
        Key[Key["Backspace"] = 8] = "Backspace";
        Key[Key["Tab"] = 9] = "Tab";
        Key[Key["Enter"] = 13] = "Enter";
        Key[Key["Shift"] = 16] = "Shift";
        Key[Key["Escape"] = 27] = "Escape";
        Key[Key["Space"] = 32] = "Space";
        Key[Key["End"] = 35] = "End";
        Key[Key["Home"] = 36] = "Home";
        Key[Key["ArrowLeft"] = 37] = "ArrowLeft";
        Key[Key["ArrowUp"] = 38] = "ArrowUp";
        Key[Key["ArrowRight"] = 39] = "ArrowRight";
        Key[Key["ArrowDown"] = 40] = "ArrowDown";
    })(Key || (Key = {}));

    var NgMentionsListComponent = /** @class */ (function () {
        function NgMentionsListComponent() {
            this.activeIndex = -1;
            this.itemSelected = new core.EventEmitter();
            this.show = false;
            this.dropUp = false;
            this._top = 0;
            this._left = 0;
        }
        Object.defineProperty(NgMentionsListComponent.prototype, "top", {
            get: function () {
                return this._top + this.adjustTop + 'px';
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgMentionsListComponent.prototype, "left", {
            get: function () {
                return this._left + 'px';
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgMentionsListComponent.prototype, "noItems", {
            get: function () {
                return !Array.isArray(this.items) || this.items.length === 0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgMentionsListComponent.prototype, "selectedItem", {
            get: function () {
                return this.activeIndex >= 0 && this.items[this.activeIndex] !== undefined ? this.items[this.activeIndex] : null;
            },
            enumerable: false,
            configurable: true
        });
        NgMentionsListComponent.prototype.ngOnInit = function () {
            if (!this.itemTemplate) {
                this.itemTemplate = this.defaultItemTemplate;
            }
        };
        NgMentionsListComponent.prototype.onItemClick = function (event, activeIndex, item) {
            event.preventDefault();
            this.activeIndex = activeIndex;
            this.itemSelected.emit(item);
        };
        NgMentionsListComponent.prototype.selectFirstItem = function () {
            this.activeIndex = 0;
            this.resetScroll();
        };
        NgMentionsListComponent.prototype.selectPreviousItem = function () {
            if (this.activeIndex > 0) {
                this.activeIndex--;
            }
            this.scrollToActiveItem();
        };
        NgMentionsListComponent.prototype.selectNextItem = function () {
            if (this.activeIndex < this.items.length - 1) {
                this.activeIndex++;
                this.scrollToActiveItem();
            }
        };
        NgMentionsListComponent.prototype.selectLastItem = function () {
            this.activeIndex = this.items.length > 0 ? this.items.length - 1 : 0;
            this.scrollToActiveItem();
        };
        NgMentionsListComponent.prototype.position = function () {
            var element = this.textAreaElement;
            var coords = getCaretCoordinates(element, element.selectionStart);
            this._top = coords.top;
            this._left = coords.left + element.offsetLeft;
            this.list.nativeElement.scrollTop = 0;
        };
        NgMentionsListComponent.prototype.resetScroll = function () {
            this.list.nativeElement.scrollTop = 0;
        };
        NgMentionsListComponent.prototype.transformItem = function (item) {
            return this.displayTransform(item) || item;
        };
        Object.defineProperty(NgMentionsListComponent.prototype, "adjustTop", {
            get: function () {
                var adjust = 0;
                if (!this.dropUp) {
                    var computedFontSize = getElementStyle(this.textAreaElement, 'fontSize');
                    adjust = parseInt(computedFontSize, 10) + this.textAreaElement.offsetTop;
                }
                return adjust;
            },
            enumerable: false,
            configurable: true
        });
        NgMentionsListComponent.prototype.scrollToActiveItem = function () {
            var element = this.list.nativeElement;
            if (this.activeIndex === 0) {
                element.scrollTop = 0;
            }
            else {
                var activeElement = element.querySelector('li.active');
                if (activeElement) {
                    element.scrollTop = activeElement.offsetTop;
                }
            }
        };
        return NgMentionsListComponent;
    }());
    NgMentionsListComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'mentions-list',
                    template: "\n      <ng-template #defaultItemTemplate let-item=\"item\">\n          {{transformItem(item)}}\n      </ng-template>\n      <ul #list class=\"dropdown-menu scrollable-menu\">\n          <li *ngFor=\"let item of items; let i = index\" [class.active]=\"activeIndex === i\">\n              <a href class=\"dropdown-item\" (click)=\"onItemClick($event, i, item)\">\n                  <ng-template [ngTemplateOutlet]=\"itemTemplate\"\n                               [ngTemplateOutletContext]=\"{item:item,index:i}\"></ng-template>\n              </a>\n          </li>\n      </ul>\n  ",
                    encapsulation: core.ViewEncapsulation.None,
                    styles: ["mentions-list{display:none;position:absolute}mentions-list.drop-up{-webkit-transform:translateY(-100%);transform:translateY(-100%)}mentions-list.show{display:block}mentions-list.no-items{display:none}mentions-list .scrollable-menu{display:block;height:auto;max-height:300px;overflow:auto}mentions-list li.active{background:#f7f7f9}mentions-list .dropdown-menu,mentions-list .dropdown-menu li{list-style:none}", 'mentions-list.show {display: block;} mentions-list.no-items {display: none;}',
                        'mentions-list .scrollable-menu {display: block;height: auto;max-height:300px;overflow:auto;}',
                        'mentions-list li.active {background: #f7f7f9;}']
                },] }
    ];
    NgMentionsListComponent.propDecorators = {
        defaultItemTemplate: [{ type: core.ViewChild, args: ['defaultItemTemplate', { static: true },] }],
        list: [{ type: core.ViewChild, args: ['list', { static: true },] }],
        show: [{ type: core.HostBinding, args: ['class.show',] }],
        dropUp: [{ type: core.HostBinding, args: ['class.drop-up',] }],
        top: [{ type: core.HostBinding, args: ['style.top',] }],
        left: [{ type: core.HostBinding, args: ['style.left',] }],
        noItems: [{ type: core.HostBinding, args: ['class.no-items',] }]
    };

    /**
     * The Mentions Component
     */
    var NgMentionsComponent = /** @class */ (function () {
        function NgMentionsComponent(element, componentResolver, viewContainer, changeDetector, ngZone) {
            this.element = element;
            this.componentResolver = componentResolver;
            this.viewContainer = viewContainer;
            this.changeDetector = changeDetector;
            this.ngZone = ngZone;
            /**
             * The character to trigger the mentions list when a user is typing in the input field
             */
            this.triggerChar = '@';
            /**
             * The markup used to format a mention in the model value
             */
            this.mentionMarkup = '@[__display__](__type__:__id__)';
            /**
             * Optional. When using a custom search (i.e. an API call), the internal searching capability should be disabled.
             */
            this.disableSearch = false;
            /**
             * Only used when internal search is not disabled. This limits the maximum number of items to display in the search
             * result list.
             */
            this.maxItems = -1;
            /**
             * Used to cause the search result list to display in a "drop up" fashion, instead of a typical dropdown.
             */
            this.dropUp = false;
            /**
             * If the supplied mentions are a list of objects, this is the name of the property used to display
             * the mention in the search result list and when formatting a mention in the displayed text.
             */
            this.displayName = 'display';
            /**
             * An event emitted, after the trigger character has been typed, with the user-entered search string.
             */
            this.search = new core.EventEmitter();
            this.valueChanges = new core.EventEmitter();
            this.stateChanges = new rxjs.Subject();
            this.displayContent = '';
            this.lines = [];
            this.highlighterStyle = {};
            this.textAreaClassNames = {};
            this.mentions = [];
            this._value = '';
            this._rows = 1;
            this._columns = 20;
            this.stopSearch = false;
            this._destroyed = new rxjs.Subject();
            this.newLine = /\n/g;
            this._errorState = false;
        }
        Object.defineProperty(NgMentionsComponent.prototype, "formClass", {
            /**
             * Classes for textarea
             */
            get: function () {
                return Object.keys(this.textAreaClassNames).join(' ');
            },
            set: function (classNames) {
                var _this = this;
                this.textAreaClassNames = {};
                Array.from(classNames.split(' ')).forEach(function (className) {
                    _this.textAreaClassNames[className] = true;
                });
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgMentionsComponent.prototype, "value", {
            get: function () {
                return this._value;
            },
            set: function (value) {
                this.parseLines(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgMentionsComponent.prototype, "required", {
            get: function () {
                return this._required;
            },
            set: function (value) {
                this._required = value;
                this.refreshStyles();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgMentionsComponent.prototype, "disabled", {
            get: function () {
                return this._disabled;
            },
            set: function (value) {
                this._disabled = value;
                this.refreshStyles();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgMentionsComponent.prototype, "rows", {
            /**
             * Number of rows for the textarea. Defaults to 1
             */
            get: function () {
                return this._rows;
            },
            set: function (value) {
                if (value !== null && typeof value !== 'undefined') {
                    if (typeof value === 'string') {
                        value = parseInt(value, 10);
                    }
                    this._rows = Math.max(1, value);
                    this.refreshStyles();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgMentionsComponent.prototype, "columns", {
            /**
             * Number of columns for the textarea. Defaults to 1
             */
            get: function () {
                return this._columns;
            },
            set: function (value) {
                if (value !== null && typeof value !== 'undefined') {
                    if (typeof value === 'string') {
                        value = parseInt(value, 10);
                    }
                    this._columns = Math.max(1, value);
                    this.refreshStyles();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgMentionsComponent.prototype, "mentionItems", {
            /**
             * The list of mentions to display, or filter, in the search result list.
             */
            set: function (value) {
                this.mentions = value;
                if (this.disableSearch && this.mentionsList) {
                    this.mentionsList.items = value;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgMentionsComponent.prototype, "readonly", {
            get: function () {
                return this.disabled ? 'readonly' : null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgMentionsComponent.prototype, "errorState", {
            get: function () {
                return this._errorState;
            },
            enumerable: false,
            configurable: true
        });
        NgMentionsComponent.prototype.ngOnInit = function () {
            this.parseMarkup();
        };
        NgMentionsComponent.prototype.ngOnChanges = function (changes) {
            if ('markup' in changes) {
                this.parseMarkup();
            }
        };
        NgMentionsComponent.prototype.ngAfterViewInit = function () {
            this.parseLines(this._value);
            this.refreshStyles();
        };
        NgMentionsComponent.prototype.ngAfterViewChecked = function () {
            this.refreshStyles();
        };
        NgMentionsComponent.prototype.ngOnDestroy = function () {
            this._destroyed.next();
            this._destroyed.complete();
        };
        NgMentionsComponent.prototype.onWindowResize = function () {
            this.refreshStyles();
        };
        NgMentionsComponent.prototype.onTextAreaScroll = function () {
            this.highlighterElement.nativeElement.scrollTop = this.textAreaInputElement.nativeElement.scrollTop;
        };
        NgMentionsComponent.prototype.onSelect = function (event) {
            this.selectionStart = event.target.selectionStart;
            this.selectionEnd = event.target.selectionEnd;
        };
        NgMentionsComponent.prototype.onChange = function (newPlainTextValue) {
            var _this = this;
            var value = this._value;
            var displayTransform = this.displayTransform.bind(this);
            var selectionStart = this.textAreaInputElement.nativeElement.selectionStart;
            var selectionEnd = this.textAreaInputElement.nativeElement.selectionEnd;
            var bounds = getBoundsOfMentionAtPosition(newPlainTextValue, this.markupSearch, selectionStart, displayTransform);
            if (bounds.start !== -1) {
                newPlainTextValue = newPlainTextValue.substring(0, bounds.start) + newPlainTextValue.substring(bounds.end);
            }
            var newValue = applyChangeToValue(value, this.markupSearch, newPlainTextValue, this.selectionStart, this.selectionEnd, selectionEnd, displayTransform);
            var startOfMention = findStartOfMentionInPlainText(value, this.markupSearch, selectionStart, displayTransform);
            if (startOfMention.start > -1 && this.selectionEnd > startOfMention.start) {
                selectionStart = startOfMention.start;
                selectionEnd = selectionStart;
            }
            this.selectionStart = Math.max(selectionStart, 0);
            this.selectionEnd = Math.max(selectionEnd, 0);
            this.parseLines(newValue);
            if (this.selectionEnd > 0) {
                setTimeout(function () { return setCaretPosition(_this.textAreaInputElement.nativeElement, _this.selectionEnd); });
            }
        };
        NgMentionsComponent.prototype.onKeyDown = function (event) {
            var caretPosition = getCaretPosition(this.textAreaInputElement.nativeElement);
            var characterPressed = event.key;
            var keyCode = event.which || event.keyCode;
            if (!characterPressed) {
                var characterCode = event.which || event.keyCode;
                characterPressed = String.fromCharCode(characterCode);
                if (!event.shiftKey && (characterCode >= 65 && characterCode <= 90)) {
                    characterPressed = String.fromCharCode(characterCode + 32);
                }
            }
            if (keyCode === Key.Enter && event.wasSelection && caretPosition < this.startPos) {
                caretPosition = this.startNode.length;
                setCaretPosition(this.startNode, caretPosition);
            }
            var startOfMention = findStartOfMentionInPlainText(this._value, this.markupSearch, caretPosition, this.displayTransform.bind(this));
            if (characterPressed === this.triggerChar) {
                this.setupMentionsList(caretPosition);
            }
            else if (startOfMention.start === -1 && this.startPos >= 0) {
                if (caretPosition <= this.startPos) {
                    this.mentionsList.show = false;
                    this.startPos = -1;
                }
                else if (keyCode !== Key.Shift && !event.shiftKey && !event.metaKey && !event.altKey && !event.ctrlKey &&
                    caretPosition > this.startPos) {
                    this.handleKeyDown(event, caretPosition, characterPressed);
                }
            }
            else {
                this.onSelect({ target: this.textAreaInputElement.nativeElement });
            }
        };
        NgMentionsComponent.prototype.onBlur = function (event) {
            if (event instanceof FocusEvent && event.relatedTarget) {
                var element = event.relatedTarget;
                if (element.classList.contains('dropdown-item')) {
                    return;
                }
            }
            this.stopEvent(event);
            if (this.mentionsList) {
                this.mentionsList.show = false;
            }
        };
        NgMentionsComponent.prototype.isPartMention = function (part) {
            return typeof part.contents !== 'undefined';
        };
        NgMentionsComponent.prototype.formatMention = function (mention) {
            return this._formatMention(mention.contents);
        };
        NgMentionsComponent.prototype.displayTransform = function () {
            var _ = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                _[_i] = arguments[_i];
            }
            var replaceIndex = this.markupSearch.groups[this.displayName];
            return _[replaceIndex];
        };
        NgMentionsComponent.prototype._formatMention = function (contents) {
            var replaceValue = "$" + this.displayName;
            var result = contents.replace(this.markupSearch.regEx, replaceValue), replaceIndex;
            if (result === replaceValue) {
                replaceIndex = "$" + this.markupSearch.groups[this.displayName];
                result = contents.replace(this.markupSearch.regEx, replaceIndex);
            }
            return result;
        };
        NgMentionsComponent.prototype.stopEvent = function (event) {
            if (event.preventDefault) {
                event.preventDefault();
                event.stopPropagation();
                event.stopImmediatePropagation();
            }
        };
        NgMentionsComponent.prototype.setupMentionsList = function (caretPosition) {
            this.startPos = caretPosition;
            this.startNode = window.getSelection().anchorNode;
            this.searchString = '';
            this.stopSearch = false;
            this.showMentionsList();
            this.updateMentionsList();
        };
        NgMentionsComponent.prototype.handleKeyDown = function (event, caretPosition, characterPressed) {
            var _this = this;
            var keyCode = event.which || event.keyCode;
            if (keyCode === Key.Space) {
                this.startPos = -1;
            }
            else if (keyCode === Key.Backspace && caretPosition > 0) {
                caretPosition--;
                if (caretPosition === this.startPos) {
                    this.stopSearch = true;
                }
                this.mentionsList.show = !this.stopSearch;
            }
            else if (this.mentionsList.show) {
                if (keyCode === Key.Tab || keyCode === Key.Enter) {
                    this.stopEvent(event);
                    this.mentionsList.show = false;
                    var value = this._value;
                    var start = mapPlainTextIndex(value, this.markupSearch, this.startPos, false, this.displayTransform.bind(this));
                    var item = event.item || this.mentionsList.selectedItem;
                    var newValue = replacePlaceholders(item, this.markupSearch);
                    var newDisplayValue = this._formatMention(newValue);
                    caretPosition = this.startPos + newDisplayValue.length;
                    var searchString = this.searchString || '';
                    value = value.substring(0, start) + newValue + value.substring(start + searchString.length + 1, value.length);
                    this.parseLines(value);
                    this.startPos = -1;
                    this.searchString = '';
                    this.stopSearch = true;
                    this.mentionsList.show = false;
                    this.changeDetector.detectChanges();
                    setTimeout(function () {
                        setCaretPosition(_this.textAreaInputElement.nativeElement, caretPosition);
                        _this.onSelect({ target: _this.textAreaInputElement.nativeElement });
                    });
                    return;
                }
                else if (keyCode === Key.Escape) {
                    this.stopEvent(event);
                    this.mentionsList.show = false;
                    this.stopSearch = true;
                    return;
                }
                else if (keyCode === Key.ArrowDown) {
                    this.stopEvent(event);
                    this.mentionsList.selectNextItem();
                    return;
                }
                else if (keyCode === Key.ArrowUp) {
                    this.stopEvent(event);
                    this.mentionsList.selectPreviousItem();
                    return;
                }
                else if (keyCode === Key.Home) {
                    this.stopEvent(event);
                    this.mentionsList.selectFirstItem();
                    return;
                }
                else if (keyCode === Key.End) {
                    this.stopEvent(event);
                    this.mentionsList.selectLastItem();
                    return;
                }
            }
            if (keyCode === Key.ArrowLeft || keyCode === Key.ArrowRight || keyCode === Key.Home || keyCode === Key.End) {
                this.onSelect(event);
                return;
            }
            var mention = this.displayContent.substring(this.startPos + 1, caretPosition);
            if (keyCode !== Key.Backspace) {
                mention += characterPressed;
            }
            this.searchString = mention || '';
            this.updateMentionsList();
        };
        NgMentionsComponent.prototype.getDisplayValue = function (item) {
            if (typeof item === 'string') {
                return item;
            }
            else if (item[this.displayName] !== undefined) {
                return item[this.displayName];
            }
            return null;
        };
        NgMentionsComponent.prototype.showMentionsList = function () {
            var _this = this;
            if (!this.mentionsList) {
                var componentFactory = this.componentResolver.resolveComponentFactory(NgMentionsListComponent);
                var componentRef = this.viewContainer.createComponent(componentFactory);
                this.mentionsList = componentRef.instance;
                this.mentionsList.itemTemplate = this.mentionListTemplate;
                this.mentionsList.displayTransform = this.displayTransform.bind(this);
                this.mentionsList.itemSelected.subscribe(function (item) {
                    _this.textAreaInputElement.nativeElement.focus();
                    var fakeEvent = { keyCode: Key.Enter, wasSelection: true, item: item };
                    _this.onKeyDown(fakeEvent);
                });
                this.mentionsList.displayTransform = this.getDisplayValue.bind(this);
            }
            this.mentionsList.textAreaElement = this.textAreaInputElement.nativeElement;
            this.mentionsList.show = true;
            this.mentionsList.dropUp = this.dropUp;
            this.mentionsList.activeIndex = 0;
            this.mentionsList.position();
            this.ngZone.run(function () { return _this.mentionsList.resetScroll(); });
        };
        NgMentionsComponent.prototype.updateMentionsList = function () {
            var _this = this;
            if (!this.disableSearch) {
                var items = Array.from(this.mentions);
                if (this.searchString) {
                    var searchString = this.searchString.toLowerCase(), searchRegEx_1 = new RegExp(escapeRegExp(searchString), 'i');
                    items = items.filter(function (item) {
                        var value = _this.getDisplayValue(item);
                        return value !== null && searchRegEx_1.test(value);
                    });
                    if (this.maxItems > 0) {
                        items = items.slice(0, this.maxItems);
                    }
                }
                this.mentionsList.items = items;
            }
            else {
                this.search.emit(this.searchString);
            }
        };
        NgMentionsComponent.prototype.parseMarkup = function () {
            if (this.mentionMarkup.length === 0 || this.mentionMarkup[0] !== this.triggerChar) {
                throw new Error("ng-mentions markup pattern must start with the trigger character \"" + this.triggerChar + "\"");
            }
            this.markupSearch = markupToRegExp(this.mentionMarkup);
        };
        NgMentionsComponent.prototype.parseLines = function (value) {
            var _this = this;
            if (value === void 0) { value = ''; }
            if (value !== this._value) {
                value = value || '';
                var lines = value.split(this.newLine).map(function (line) { return _this.formatMentions(line); });
                var displayContent = lines.map(function (line) { return line.content; }).join('\n');
                if (this.displayContent !== displayContent) {
                    this.lines = lines;
                    this.displayContent = displayContent;
                    this.triggerChange(value);
                }
            }
        };
        NgMentionsComponent.prototype.formatMentions = function (line) {
            var _this = this;
            var lineObj = { originalContent: line, content: line, parts: [] };
            if (line.length === 0) {
                return lineObj;
            }
            var mention;
            var tags = [];
            var regEx = this.markupSearch.regEx;
            regEx.lastIndex = 0;
            while ((mention = regEx.exec(line)) !== null) {
                tags.push({ indices: { start: mention.index, end: mention.index + mention[0].length } });
            }
            var prevTags = [];
            var content = '';
            __spread(tags).sort(function (tagA, tagB) { return tagA.indices.start - tagB.indices.start; }).forEach(function (tag) {
                var expectedLength = tag.indices.end - tag.indices.start;
                var contents = line.slice(tag.indices.start, tag.indices.end);
                if (contents.length === expectedLength) {
                    var prevIndex = prevTags.length > 0 ? prevTags[prevTags.length - 1].indices.end : 0;
                    var before = line.slice(prevIndex, tag.indices.start);
                    var partMention = { contents: contents, tag: tag };
                    lineObj.parts.push(before);
                    lineObj.parts.push(partMention);
                    prevTags.push(tag);
                    content += before + _this.formatMention(partMention);
                }
            });
            var remainingStart = prevTags.length > 0 ? prevTags[prevTags.length - 1].indices.end : 0;
            var remaining = line.slice(remainingStart);
            lineObj.parts.push(remaining);
            content += remaining;
            lineObj.content = content;
            return lineObj;
        };
        NgMentionsComponent.prototype.refreshStyles = function () {
            var _this = this;
            if (!this.textAreaInputElement) {
                return;
            }
            var element = this.textAreaInputElement.nativeElement;
            var computedStyle = getComputedStyle(element);
            this.highlighterStyle = {};
            styleProperties.forEach(function (prop) {
                _this.highlighterStyle[prop] = computedStyle[prop];
            });
            this.changeDetector.detectChanges();
        };
        NgMentionsComponent.prototype.triggerChange = function (value) {
            this._value = value;
            this.valueChanges.emit(this._value);
            this.changeDetector.detectChanges();
        };
        return NgMentionsComponent;
    }());
    NgMentionsComponent.decorators = [
        { type: core.Component, args: [{
                    exportAs: 'ngMentions',
                    selector: 'ng-mentions',
                    template: "\n      <div #highlighter class=\"highlighter\" [ngClass]=\"textAreaClassNames\" [attr.readonly]=\"readonly\"\n           [ngStyle]=\"highlighterStyle\">\n          <div *ngFor=\"let line of lines\">\n              <ng-container *ngFor=\"let part of line.parts\">\n                  <highlighted *ngIf=\"isPartMention(part)\" [tag]=\"part.tag\">{{formatMention(part)}}</highlighted>\n                  <ng-container *ngIf=\"!isPartMention(part)\">{{part}}</ng-container>\n              </ng-container>\n              &nbsp;\n          </div>\n      </div>\n      <textarea\n        #input\n        [rows]=\"rows\"\n        [cols]=\"columns\"\n        [ngModel]=\"displayContent\"\n        [ngClass]=\"textAreaClassNames\"\n        (keydown)=\"onKeyDown($event)\"\n        (blur)=\"onBlur($event)\"\n        (select)=\"onSelect($event)\"\n        (mouseup)=\"onSelect($event)\"\n        (ngModelChange)=\"onChange($event)\"\n        (scroll)=\"onTextAreaScroll()\"\n        [disabled]=\"disabled\"\n        [required]=\"required\"\n        [placeholder]=\"placeholder\"\n      ></textarea>\n  ",
                    preserveWhitespaces: false,
                    encapsulation: core.ViewEncapsulation.None,
                    styles: ["ng-mentions{display:inline-block;position:relative}ng-mentions textarea{background-color:transparent!important;position:relative}ng-mentions .highlighter{bottom:0;color:transparent;left:0;overflow:hidden!important;position:absolute;right:0;top:0}ng-mentions highlighted{background-color:#add8e6;border-radius:3px;display:inline;margin:-1px;overflow-wrap:break-word;padding:1px}"]
                },] }
    ];
    NgMentionsComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.ComponentFactoryResolver },
        { type: core.ViewContainerRef },
        { type: core.ChangeDetectorRef },
        { type: core.NgZone }
    ]; };
    NgMentionsComponent.propDecorators = {
        triggerChar: [{ type: core.Input, args: ['triggerChar',] }],
        mentionMarkup: [{ type: core.Input, args: ['markup',] }],
        disableSearch: [{ type: core.Input, args: ['disableSearch',] }],
        maxItems: [{ type: core.Input, args: ['maxItems',] }],
        dropUp: [{ type: core.Input, args: ['dropUp',] }],
        displayName: [{ type: core.Input, args: ['displayName',] }],
        placeholder: [{ type: core.Input, args: ['placeholder',] }],
        search: [{ type: core.Output, args: ['search',] }],
        valueChanges: [{ type: core.Output, args: ['valueChanges',] }],
        stateChanges: [{ type: core.Output, args: ['stateChanges',] }],
        mentionListTemplate: [{ type: core.ContentChild, args: [core.TemplateRef, { static: true },] }],
        textAreaInputElement: [{ type: core.ViewChild, args: ['input', { static: true },] }],
        highlighterElement: [{ type: core.ViewChild, args: ['highlighter', { static: true },] }],
        formClass: [{ type: core.Input, args: ['formClass',] }],
        value: [{ type: core.Input, args: ['value',] }],
        required: [{ type: core.Input, args: ['required',] }],
        disabled: [{ type: core.Input, args: ['disabled',] }],
        rows: [{ type: core.Input, args: ['rows',] }],
        columns: [{ type: core.Input, args: ['cols',] }],
        mentionItems: [{ type: core.Input, args: ['mentions',] }],
        onWindowResize: [{ type: core.HostListener, args: ['window:resize',] }]
    };

    /**
     * The NgMentionsAccessorDirective directive is used to indicate the input element.
     */
    var NgMentionsAccessorDirective = /** @class */ (function () {
        function NgMentionsAccessorDirective(element, host) {
            this.element = element;
            this.host = host;
            this._destroyed = new rxjs.Subject();
        }
        NgMentionsAccessorDirective.prototype.ngOnInit = function () {
            var _this = this;
            this.host.valueChanges.pipe(operators.takeUntil(this._destroyed)).subscribe(function (value) { return _this.onChange(value); });
        };
        NgMentionsAccessorDirective.prototype.ngOnDestroy = function () {
            this._destroyed.next();
            this._destroyed.complete();
        };
        NgMentionsAccessorDirective.prototype.registerOnChange = function (fn) {
            this._onChange = fn;
        };
        NgMentionsAccessorDirective.prototype.registerOnTouched = function (fn) {
            this._onTouch = fn;
        };
        NgMentionsAccessorDirective.prototype.setDisabledState = function (isDisabled) {
            this.host.disabled = isDisabled;
        };
        NgMentionsAccessorDirective.prototype.writeValue = function (value) {
            if (typeof value === 'string' || value === null) {
                this.host.value = value;
            }
        };
        NgMentionsAccessorDirective.prototype.onChange = function (value) {
            if (this._onChange && typeof value !== 'object') {
                this._onChange(value);
            }
        };
        NgMentionsAccessorDirective.prototype.onTouched = function () {
            if (this._onTouch) {
                this._onTouch();
            }
        };
        return NgMentionsAccessorDirective;
    }());
    NgMentionsAccessorDirective.decorators = [
        { type: core.Directive, args: [{
                    exportAs: 'ngMentions',
                    selector: 'ng-mentions',
                    host: { '(change)': 'onChange($event)', '(touch)': 'onTouched()' },
                    providers: [{ provide: forms.NG_VALUE_ACCESSOR, useExisting: core.forwardRef(function () { return NgMentionsAccessorDirective; }), multi: true }]
                },] }
    ];
    NgMentionsAccessorDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: NgMentionsComponent }
    ]; };

    var HighlightedDirective = /** @class */ (function () {
        function HighlightedDirective() {
        }
        return HighlightedDirective;
    }());
    HighlightedDirective.decorators = [
        { type: core.Directive, args: [{ selector: 'highlighted' },] }
    ];
    HighlightedDirective.propDecorators = {
        tag: [{ type: core.Input }]
    };

    var EXPORT_DIRECTIVES = [
        NgMentionsComponent,
        NgMentionsAccessorDirective,
        NgHighlighterComponent,
        NgHighlighterPatternDirective,
    ];
    var DECLARATIONS = [
        NgMentionsComponent, NgMentionsAccessorDirective, NgMentionsListComponent, HighlightedDirective,
        NgHighlighterComponent, NgHighlighterPatternDirective
    ];
    var NgMentionsModule = /** @class */ (function () {
        function NgMentionsModule() {
        }
        return NgMentionsModule;
    }());
    NgMentionsModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, forms.FormsModule],
                    exports: EXPORT_DIRECTIVES,
                    declarations: DECLARATIONS,
                    entryComponents: [NgMentionsListComponent]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgHighlighterComponent = NgHighlighterComponent;
    exports.NgMentionsAccessorDirective = NgMentionsAccessorDirective;
    exports.NgMentionsComponent = NgMentionsComponent;
    exports.NgMentionsModule = NgMentionsModule;
    exports.ɵa = NgHighlighterPatternDirective;
    exports.ɵb = NgMentionsListComponent;
    exports.ɵc = HighlightedDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-mentions.umd.js.map
